it-swarm.com.de

Wie kann ich das JavaScript eines Moduls ändern?

Ich muss den JavaScript-Code des Moduls "Webform AJAX" ändern. Ist dies möglich, ohne das Modul zu hacken und das Risiko einzugehen, alles bei Modulaktualisierungen zu verlieren?

11
dibs

Sie können hook_js_alter () in einem Modul verwenden. Dieser Code ersetzt beispielsweise die von Drupal] verwendete jQuery-Bibliothek durch die im Verzeichnis jquery_update vorhandene Datei.

function jquery_update_js_alter(&$javascript) {
  // Swap out jQuery to use an updated version of the library.
  $javascript['misc/jquery.js']['data'] = drupal_get_path('module', 'jquery_update') . '/jquery.js';
} 

Gleiches gilt für Inline-JavaScript-Code. Die Unterschiede sind:

  • Anstelle von 'misc/jquery.js' Ist der erste Index eine Zahl
  • $javascript[$index]['data'] Enthält den JavaScript-Code

Dies bedeutet, dass Sie zuerst den Eintrag finden müssen, den der JavaScript-Code ersetzen soll, und ihn dann ändern müssen. Der folgende Code sollte in diesem Fall funktionieren.

function mymodule_js_alter(&$javascript) {
  $old_code = 'The code to alter';
  $new_code = 'The new code';

  foreach ($javascript as $index => $info) {
    if (is_numeric($index) && $info['data'] == $old_code) {
      $javascript[$index]['data'] = $new_code;
      break;
    }
  }
}

Wenn Sie die von einem Modul implementierte Bibliothek ändern müssen, können Sie alternativ hook_library_alter () implementieren. Dies ist beispielsweise der Code, der von der neuesten Version des Moduls jQuery Update implementiert wurde.

function jquery_update_library_alter(&$javascript, $module) {

  // We are updating just the system module. For all other cases we return.
  if ($module != 'system') {
    return;
  }

  $path = drupal_get_path('module', 'jquery_update');

  // Make sure we inject either the minified or uncompressed version as desired.
  $min = variable_get('jquery_update_compression_type', 'min') == 'none' ? '' : '.min';
  $cdn = variable_get('jquery_update_jquery_cdn', 'none');

  // Replace jQuery with the latest version.
  $version = variable_get('jquery_update_jquery_version', '1.5');
  jquery_update_jquery_replace($javascript, $cdn, $path, $min, $version);

  // Replace jQuery UI with CDN or local files. If from a CDN include all of jQuery UI.
  jquery_update_jqueryui_replace($javascript, $cdn, $path, $min);

  // Replace the jQuery Cookie plugin.
  $javascript['cookie']['js']['misc/jquery.cookie.js']['data'] = $path . '/replace/ui/external/jquery.cookie.js';
  // Noting the version based on git commit as no version number is available.
  $javascript['cookie']['version'] = '67fb34f6a866c40d0570';

  // Replace jQuery Form plugin.
  $javascript['jquery.form']['js']['misc/jquery.form.js']['data'] = $path . '/replace/misc/jquery.form' . $min . '.js';
  $javascript['jquery.form']['version'] = '2.69';

  // Replace files for jQuery 1.7 and up
  if (version_compare($version, '1.7', '>=')) {
    $javascript['drupal.states']['js']['misc/states.js']['data'] = $path . '/replace/misc/1.7/states.js';
  }
}

Dies gilt auch für JavaScript-Code, der von Drupal core) verwendet wird, da das Systemmodul für diese JavaScript-Dateien hook_library () implementiert. (Siehe system_library () ) .)

hook_js_alter() kann für jede JavaScript-Datei/jeden JavaScript-Code verwendet werden, auch für Dateien, die von Drupal core. Zwischen hook_js_alter() und hook_library_alter() verwendet werden Letzteres ist vorzuziehen, wenn die JavaScript-Dateien als Bibliothek verfügbar gemacht werden.

19
kiamlaluno